/*
 * Copyright (c) 2001-2006, John Mettraux, OpenWFE.org
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 * 
 * . Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.  
 * 
 * . Redistributions in binary form must reproduce the above copyright notice, 
 *   this list of conditions and the following disclaimer in the documentation 
 *   and/or other materials provided with the distribution.
 * 
 * . Neither the name of the "OpenWFE" nor the names of its contributors may be
 *   used to endorse or promote products derived from this software without
 *   specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: Application.java 2673 2006-05-26 21:08:46Z jmettraux $
 */

//
// Application.java
//
// jmettraux@openwfe.org
//
// generated with 
// jtmpl 1.0.04 20.11.2001 John Mettraux (jmettraux@openwfe.org)
//

package openwfe.org;

import openwfe.org.app.ApplicationContextBuilder;


/**
 * Just a class that builds and interpret an ApplicationContext
 *
 * <p><font size=2>CVS Info :
 * <br>$Author: jmettraux $
 * <br>$Date: 2006-05-26 23:08:46 +0200 (Fri, 26 May 2006) $
 * <br>$Id: Application.java 2673 2006-05-26 21:08:46Z jmettraux $ </font>
 *
 * @author john.mettraux@openwfe.org
 */
public class Application
{

    private final static org.apache.log4j.Logger log = org.apache.log4j.Logger
        .getLogger(Application.class.getName());

    //
    // CONSTANTS

    public final static String VERSION =
        "OpenWFE application v1.13 - john.mettraux )at( openwfe.org";

    //
    // STATIC 

    private static java.util.Timer timer = new java.util.Timer(true);

    /**
     * The timer available to the whole application
     */
    public static java.util.Timer getTimer () { return timer; }

    //
    // FIELDS

    //
    // CONSTRUCTORS

    //
    // METHODS

    //
    // the MAIN METHOD

    public static void main (String[] args)
    {
        String builderClassName = 
            openwfe.org.app.XmlApplicationContextBuilder.class.getName();
        String configurationFileName = 
            "etc/application-configuration.xml";

        if (args.length == 1)
        {
            configurationFileName = args[0];
        }
        else if (args.length == 2)
        {
            builderClassName = args[0];
            configurationFileName = args[1];
        }

        try
        {
            //new Application(builderClassName, configurationFileName);

            log.info(VERSION);
            
            final ApplicationContextBuilder builder = 
                (ApplicationContextBuilder)ReflectionUtils
                    .buildNewInstance(builderClassName);

            builder.build(configurationFileName);
        }
        catch (final Exception e)
        {
            System.out.println("\nFailed to launch application.\n");
            e.printStackTrace();
        }
    }

}
