/*
 * Copyright (c) 2001-2006, John Mettraux, OpenWFE.org
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 * 
 * . Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.  
 * 
 * . Redistributions in binary form must reproduce the above copyright notice, 
 *   this list of conditions and the following disclaimer in the documentation 
 *   and/or other materials provided with the distribution.
 * 
 * . Neither the name of the "OpenWFE" nor the names of its contributors may be
 *   used to endorse or promote products derived from this software without
 *   specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: Principal.java 2914 2006-07-03 21:35:23Z jmettraux $
 */

//
// Principal.java
//
// jmettraux@openwfe.org
//
// generated with 
// jtmpl 1.0.04 31.10.2002 John Mettraux (jmettraux@openwfe.org)
//

package openwfe.org.auth;

/**
 * OpenWFE's Principal
 *
 * <p><font size=2>CVS Info :
 * <br>$Author: jmettraux $
 * <br>$Date: 2006-07-03 23:35:23 +0200 (Mon, 03 Jul 2006) $
 * <br>$Id: Principal.java 2914 2006-07-03 21:35:23Z jmettraux $ </font>
 *
 * @author john.mettraux@openwfe.org
 */
public interface Principal

    extends 
        java.io.Serializable, 
        java.security.Principal

{

    public void init (java.util.Map initParameters)
        throws AuthException;

    /**
     * Returns the params as they were used to build the
     * Principal (may be useful for Principal encoding)
     */
    public java.util.Map getInitParameters ();

    public boolean authentify (Object credentials)
        throws AuthException;

    public java.util.Set getGrants ();

    /**
     * Returns a clone of this Principal without the authentification 
     * credentials (auth has just been done, and the returned principal
     * is meant to be stored in a Subject)
     */
    public Principal getWorkCopy (String principalName);

    /**
     * Returns true if this principal is just a copy (given upon a 
     * successful authentification).
     */
    public boolean isCopy ();

    /**
     * Returns the name under which the principal logged in (not necessarily
     * equal to this.getName().
     */
    public String getOwfePrincipalName ();

    //
    // UMAN methods

    public void addGrant (String grantName);

    public void removeGrant (String grantName);

}
